﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Navigation;
using System.Windows.Shapes;
using AxisGroupingDemo.Data.Model;

namespace AxisGroupingDemo.View
{
    /// <summary>
    /// Interaction logic for CategoricalAxisGrouping.xaml
    /// </summary>
    public partial class CategoricalAxisGrouping : UserControl
    {
        public CategoricalAxisGrouping()
        {
            InitializeComponent();
            flexChart.ItemsSource = Unit.Data();
        }

        private void nbLevels_ValueChanged(object sender, C1.WPF.PropertyChangedEventArgs<double> e)
        {
            if (flexChart != null)
            {
                if (chbFlatData.IsChecked == true)
                    GroupFlatData();
                else
                    GroupHierarchicalData();
            }
        }

        private void OnFlatDataCheckChanged(object sender, RoutedEventArgs e)
        {
            if (flexChart != null)
            {
                if (chbFlatData.IsChecked == false)
                    GroupHierarchicalData();
                else
                    GroupFlatData();
            }
            
        }
        private void GroupHierarchicalData()
        {
            switch (nbLevels.Value)
            {
                case 0:
                default:
                    flexChart.ItemsSource = HierarchicalUnit.SingleLevelData();
                    flexChart.AxisX.GroupNames = null;
                    flexChart.AxisX.GroupItemsPath = null;
                    break;
                case 1:
                    flexChart.ItemsSource = HierarchicalUnit.SingleLevelData();
                    flexChart.AxisX.GroupNames = "Country";
                    flexChart.AxisX.GroupItemsPath = "Items";
                    break;
                case 2:
                    flexChart.ItemsSource = HierarchicalUnit.Data();
                    flexChart.AxisX.GroupNames = "Continent,Country";
                    flexChart.AxisX.GroupItemsPath = "Items";
                    break;
            }
        }
        private void GroupFlatData()
        {
            flexChart.ItemsSource = Unit.Data();
            flexChart.AxisX.GroupItemsPath = null;
            switch (nbLevels.Value)
            {
                case 0:
                default:
                    flexChart.AxisX.GroupNames = null;
                    break;
                case 1:
                    flexChart.AxisX.GroupNames = "Country";
                    break;
                case 2:
                    flexChart.AxisX.GroupNames = "Continent,Country";
                    break;
            }
        }
    }
}
